/*
 * Copyright (C) 2023, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: wangyan <wangyan@kylinos.cn>
 *
 */

#ifndef DEVICEMONITOR_H
#define DEVICEMONITOR_H

#include <QObject>
#include <KF5/KScreen/kscreen/types.h>

#include "common.h"

class InputDeviceMonitor;
class DeviceMonitor : public QObject
{
    Q_OBJECT
public:
    static DeviceMonitor* getInstance();

signals:
    void deviceAdded(DeviceType type, int deviceid);
    void deviceRemoved(DeviceType type, int deviceid);
    void deviceEnabled(DeviceType type, int deviceid);
    void deviceDisabled(DeviceType type, int deviceid);

private slots:
    void onOutputDeviceChanged(const KScreen::OutputPtr& output);

private:
    explicit DeviceMonitor(QObject *parent = nullptr);
    void initInputMonitor();
    void initOutputMonitor();

    KScreen::ConfigPtr m_config = nullptr;
};

#endif // DEVICEMONITOR_H
